VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'Kein
   ClientHeight    =   3405
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4785
   Icon            =   "D3D.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3405
   ScaleWidth      =   4785
   StartUpPosition =   2  'Bildschirmmitte
   WindowState     =   2  'Maximiert
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Loading..."
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   975
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Daniel Netz
' Email: netz@home.se
'
' Bitte richten Sie sich mit Fragen nicht an den Autor,
' sondern verwenden Sie das Forum auf www.visualbasicworld.de
'
' Date: 2000-03-20
' Requirements: DX7 Library for VB, Win32 library by Patrice Scribe
'
' Use this code at your own risc!!!
'
' Note that the rendering is really fast the first second,
' this is to decide the proper frame rate...I didn't have time
' to do anything about it
'
' If you get a black screen when running it, it may be because
' you graphics card doesn't support the selected screen mode.
' You should therefore run the D3D HAl device in 640x480x16
'
' Daniel Netz, Sentinel Design

Option Explicit

Dim DefaultRect As RECT

Dim Running As Boolean
Dim nStartTime As Long
Dim nEndTime As Long
Dim FPS, frames As Integer, frame_speed As Single

Dim matView As D3DMATRIX, matProj As D3DMATRIX, matWorld As D3DMATRIX

Dim Material As D3DMATERIAL7
Dim bShowFPS As Boolean

Private Sub Form_KeyPress(KeyAscii As Integer)

    If KeyAscii = 102 Then bShowFPS = Not bShowFPS
    If KeyAscii = vbKeyEscape Then Shutdown
    
End Sub

Private Sub Form_Load()

    InitDD
    InitD3D

End Sub

Sub InitDD()
On Error GoTo Report

    Dim ddsdF As DDSURFACEDESC2
    Dim ddsdB As DDSURFACEDESC2
    Dim ddscaps As DDSCAPS2
    
    SetWindowLong Me.hWnd, GWL_STYLE, WS_POPUP Or WS_VISIBLE
    ShowWindow Me.hWnd, SW_SHOW
    SetWindowPos Me.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE
    
    DD.SetCooperativeLevel Me.hWnd, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
    DD.SetDisplayMode ScreenResX, ScreenResY, ScreenBPP, 0, DDSDM_DEFAULT
    
    With DefaultRect
        .Left = 0
        .Top = 0
        .Right = ScreenResX
        .Bottom = ScreenResY
    End With
    
    With ddsdF
        .lFlags = DDSD_CAPS
        .ddscaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_VIDEOMEMORY
    End With
    
    Set FrontS = DD.CreateSurface(ddsdF)
    
    With ddsdB
        .lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT
        .ddscaps.lCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_3DDEVICE Or DDSCAPS_VIDEOMEMORY
        .lWidth = ScreenResX
        .lHeight = ScreenResY
    End With
    
    Set BackS = DD.CreateSurface(ddsdB)
    
    Set Clipper = DD.CreateClipper(0)
    Clipper.SetHWnd Me.hWnd
    FrontS.SetClipper Clipper
    
    BackS.SetForeColor RGB(255, 255, 255)
    
    InitD3D

Report:
    If Err.Number <> 0 Then MsgBox "Error " & Err.Description & " (" & Err.Number & ")"
End Sub

Sub InitD3D()
'On Error GoTo Report

    Dim VPDesc As D3DVIEWPORT7

    'create d3ddevice
    Set D3DDevice = D3D.CreateDevice(D3DGUID, BackS)
    
    'viewport stuff
    VPDesc.lWidth = DefaultRect.Right - DefaultRect.Left
    VPDesc.lHeight = DefaultRect.Bottom - DefaultRect.Top
    VPDesc.minz = 0
    VPDesc.maxz = 1
    D3DDevice.SetViewport VPDesc
    
    'cache viewport
    With Viewport(0)
        .X1 = 0
        .Y1 = 0
        .X2 = VPDesc.lWidth
        .Y2 = VPDesc.lHeight
    End With

    'material
    With Material
        .Ambient.r = 0.3
        .Ambient.g = 0.3
        .Ambient.b = 0.45
        .power = 0.35
    End With
    
    'set material
    D3DDevice.SetMaterial Material

    'set scene matrices
    DX.IdentityMatrix matWorld
    D3DDevice.SetTransform D3DTRANSFORMSTATE_WORLD, matWorld

    DX.IdentityMatrix matView
    DX.ViewMatrix matView, MakeVector(0, 0, 0), MakeVector(0, 0, 0), MakeVector(0, 1, 0), 0
    D3DDevice.SetTransform D3DTRANSFORMSTATE_VIEW, matView
    
    DX.IdentityMatrix matProj
    DX.ProjectionMatrix matProj, 0.001, 1, Pi / 2
    D3DDevice.SetTransform D3DTRANSFORMSTATE_PROJECTION, matProj
    
    'set render states
    D3DDevice.SetRenderState D3DRENDERSTATE_AMBIENT, DX.CreateColorRGBA(1, 1, 1, 1)
    D3DDevice.SetRenderState D3DRENDERSTATE_CULLMODE, D3DCULL_NONE
    
    'bilinear filtering...neat
    D3DDevice.SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTFG_LINEAR
    
    'blending states, blending factor one (1, 1, 1, 1)
    D3DDevice.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
    D3DDevice.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
    D3DDevice.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE

    'set camera/viewport variables
    ResetCamera
    TransformCamera
    Running = True
    
    'load textures and init scene objects
    Set Texture(1) = CreateTextureSurface(App.Path & "\delic.bmp", 128, 128)
    Set Texture(2) = CreateTextureSurface(App.Path & "\plurp.bmp", 128, 128)
    Set Texture(3) = CreateTextureSurface(App.Path & "\gaia.bmp", 128, 128)
    
    CreatePlanes
    
    'start rendering
    bShowFPS = True
    spinCounter = 0.001
    Me.Show
    RenderScene
    
    Exit Sub
Report:
    MsgBox "Error " & Err.Description & " (" & Err.Number & ")"
    Shutdown
End Sub

Sub Render3D()
On Error GoTo Show

    D3DDevice.Clear 1, Viewport(), D3DCLEAR_TARGET, RGB(0, 0, 0), 0, 0
    
    D3DDevice.BeginScene
        
        spinCounter = spinCounter + 0.0000008 + frame_speed
        
        'move texels (texture) coords
        For I = 0 To 5
            Plane2(I).tu = Plane2(I).tu + 0.0000005 + frame_speed
            Plane2(I).tv = Plane2(I).tv + 0.0000003 + frame_speed
            
            Plane(I).tu = Plane(I).tu - 0.0000003 + frame_speed
            Plane(I).tv = Plane(I).tv - 0.0000001 + frame_speed
        Next I
        
        'transform and render first plane
        RotateWorld 0, 0, 0, 0, 0, -spinCounter / 5
        D3DDevice.SetTexture 0, Texture(3)
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Plane2(0), 6, D3DDP_DEFAULT
        
        'transform and render second plane
        RotateWorld 0, 0, 0, 0, 0, spinCounter
        D3DDevice.SetTexture 0, Texture(1)
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Plane(0), 6, D3DDP_DEFAULT
        
        'transform and render third plane
        RotateWorld 0, 0, 0, 0, 0, -spinCounter
        D3DDevice.SetTexture 0, Texture(2)
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Plane(0), 6, D3DDP_DEFAULT
        
        If bShowFPS = True Then BackS.DrawText 3, 10, "FPS: " & FPS & ", frame_speed: " & frame_speed, True
                
    D3DDevice.EndScene
    
    Exit Sub
    
Show:
    DD.FlipToGDISurface
    DD.RestoreAllSurfaces
    MsgBox "Error " & Err.Description & " (" & Err.Number & ")"
    Shutdown
End Sub

Sub RenderScene()
    
    Dim TextY As Long
    
    Do
        Render3D
        
        'do blits
        FrontS.Blt DefaultRect, BackS, DefaultRect, DDBLT_WAIT
        BackS.BltColorFill DefaultRect, RGB(0, 0, 0)
        
        'get fps
        nStartTime = timeGetTime()
        frames = frames + 1
        If FPS = 0 Then FPS = 500
        If (nStartTime - nEndTime) > 1000 Then
            FPS = frames
            On Local Error Resume Next
            frame_speed = 0.027 / FPS '0.027 is the speed of update
            frames = 0
            nEndTime = timeGetTime()
        End If
        
        DoEvents
    Loop
    
    Shutdown
End Sub
    
Sub TransformCamera()

    Dim vUp As D3DVECTOR, vTemp As D3DVECTOR

    vUp = MakeVector(0, 1, 0)

    DX.IdentityMatrix matView
    DX.ViewMatrix matView, camera, camera_target, vUp, 0
    D3DDevice.SetTransform D3DTRANSFORMSTATE_VIEW, matView

End Sub

Sub ResetCamera()

    camera.X = 0
    camera.Y = 0
    camera.Z = -0.35
    'camera.Z = -0.8
    
    camera_target.X = camera.X
    camera_target.Y = camera.Y
    camera_target.Z = camera.Z + 3
    
End Sub

Public Function Shutdown()

    Set BackS = Nothing
    Set FrontS = Nothing
    Set DD = Nothing

    Unload frmMain
    End
    
End Function

