Attribute VB_Name = "D3DStuff"

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Daniel Netz
' Email: netz@home.se
'
' Bitte richten Sie sich mit Fragen nicht an den Autor,
' sondern verwenden Sie das Forum auf www.visualbasicworld.de
'
' Date: 2000-03-20
' Requirements: DX7 Library for VB, Win32 library by Patrice Scribe
'
' Use this code at your own risc!!!
'
' Note that the rendering is really fast the first second,
' this is to decide the proper frame rate...I didn't have time
' to do anything about it
'
' If you get a black screen when running it, it may be because
' you graphics card doesn't support the selected screen mode.
' You should therefore run the D3D HAl device in 640x480x16
'
' Daniel Netz, Sentinel Design

Option Explicit

Public Const Pi As Single = 3.141592

Public DX As New DirectX7
Public DD As DirectDraw7
Public D3D As Direct3D7
Public D3DDevice  As Direct3DDevice7
Public Clipper As DirectDrawClipper

Public Viewport(0) As D3DRECT

Public FrontS As DirectDrawSurface7
Public BackS As DirectDrawSurface7

Public Texture(1 To 3) As DirectDrawSurface7

Public D3DGUID As String
Public ScreenResX As Long
Public ScreenResY As Long
Public ScreenBPP As Long

Public I As Long
Public counter As Single, spinCounter As Single

Public Plane(5) As D3DVERTEX
Public Plane2(5) As D3DVERTEX

Public camera As D3DVECTOR
Public camera_target As D3DVECTOR

Public Function MakeVector(X As Single, Y As Single, Z As Single) As D3DVECTOR

    Dim vecOut As D3DVECTOR
    
    With vecOut
        .X = X
        .Y = Y
        .Z = Z
    End With
    
    MakeVector = vecOut
    
End Function

Public Function RotateWorld(X As Single, Y As Single, Z As Single, yaw As Single, pitch As Single, roll As Single)

    Dim matWorld As D3DMATRIX
    Dim matTemp As D3DMATRIX
    Dim matRotation As D3DMATRIX

    DX.IdentityMatrix matWorld
    matWorld.rc41 = X
    matWorld.rc42 = Y
    matWorld.rc43 = Z
    
    DX.IdentityMatrix matRotation

    If yaw <> 0 Then
    DX.RotateYMatrix matTemp, yaw
    DX.MatrixMultiply matRotation, matRotation, matTemp
    End If
    
    If pitch <> 0 Then
    DX.RotateXMatrix matTemp, pitch
    DX.MatrixMultiply matRotation, matRotation, matTemp
    End If

    If roll <> 0 Then
    DX.RotateZMatrix matTemp, roll
    DX.MatrixMultiply matRotation, matRotation, matTemp
    End If
     
    DX.MatrixMultiply matWorld, matRotation, matWorld
    D3DDevice.SetTransform D3DTRANSFORMSTATE_WORLD, matWorld

End Function

Public Sub CreatePlanes()

    'fill the vertex arrays to create the planes
    'using -0.5 and +0.5 makes the 0,0,0 vertex the middle of the plane,
    'therefor you can rotate it around its center
    
    DX.CreateD3DVertex -0.5, -0.5, 0, 0, 0, 0, 0, 0, Plane(0)
    DX.CreateD3DVertex -0.5, 0.5, 0, 0, 0, 0, 0, 3, Plane(1)
    DX.CreateD3DVertex 0.5, 0.5, 0, 0, 0, 0, 3, 3, Plane(2)
    DX.CreateD3DVertex 0.5, 0.5, 0, 0, 0, 0, 3, 3, Plane(3)
    DX.CreateD3DVertex 0.5, -0.5, 0, 0, 0, 0, 3, 0, Plane(4)
    DX.CreateD3DVertex -0.5, -0.5, 0, 0, 0, 0, 0, 0, Plane(5)
    
    DX.CreateD3DVertex -0.5, -0.5, 0, 0, 0, 0, 0, 0, Plane2(0)
    DX.CreateD3DVertex -0.5, 0.5, 0, 0, 0, 0, 0, 3, Plane2(1)
    DX.CreateD3DVertex 0.5, 0.5, 0, 0, 0, 0, 3, 3, Plane2(2)
    DX.CreateD3DVertex 0.5, 0.5, 0, 0, 0, 0, 3, 3, Plane2(3)
    DX.CreateD3DVertex 0.5, -0.5, 0, 0, 0, 0, 3, 0, Plane2(4)
    DX.CreateD3DVertex -0.5, -0.5, 0, 0, 0, 0, 0, 0, Plane2(5)

End Sub

Public Function CreateTextureSurface(sFile As String, w As Long, h As Long) As DirectDrawSurface7

    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim I As Long
    Dim DDSD As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean

    DDSD.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If ((h <> 0) And (w <> 0)) Then
        DDSD.lFlags = DDSD.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        DDSD.lHeight = h
        DDSD.lWidth = w
    End If
    
    Set enumTex = D3DDevice.GetTextureFormatsEnum()

    'check if device supports 16bit surfaces
    For I = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(I, DDSD.ddpfPixelFormat)

        With DDSD.ddpfPixelFormat
            If .lRGBBitCount <> 16 Then bOK = False
        End With
        If bOK = True Then Exit For
    Next

    If bOK = False Then
        Debug.Print "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If

    'set some texture surface flags
    If D3DDevice.GetDeviceGuid() = "IID_IDirect3DHALDevice" Then
            DDSD.ddscaps.lCaps = DDSCAPS_TEXTURE 'Or DDSCAPS_VIDEOMEMORY
            DDSD.ddscaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            DDSD.lTextureStage = 0
    Else
            DDSD.ddscaps.lCaps = DDSCAPS_TEXTURE 'Or DDSCAPS_VIDEOMEMORY
            DDSD.ddscaps.lCaps2 = 0
            DDSD.lTextureStage = 0
    End If

    If sFile = "" Then
        Set SurfaceObject = DD.CreateSurface(DDSD)
    Else
        Set SurfaceObject = DD.CreateSurfaceFromFile(sFile, DDSD)
    End If

    Set CreateTextureSurface = SurfaceObject

End Function
